<template>
  <BasicModal
    v-bind="$attrs"
    @register="register"
    :title="t('routes.corporation.addCorporation')"
    @visible-change="handleVisibleChange"
    @ok="handleSubmit"
    @cancel="resetFields"
  >
    <div class="pt-2px pr-3px">
      <BasicForm @register="registerForm" :model="model" />
    </div>
  </BasicModal>
</template>
<script lang="ts">
  import { defineComponent, ref, nextTick } from 'vue';
  import { BasicModal, useModalInner } from '/@/components/Modal';
  import { BasicForm, FormSchema, useForm } from '/@/components/Form/index';
  import { useMessage } from '/@/hooks/web/useMessage';
  // import { checkUserAddAble } from '/@/api/corporation/modal';
  import { useI18n } from '/@/hooks/web/useI18n';
  import { uploadLogoApi, insertCompnayApi } from '/@/api/corporation/list';
  const { t } = useI18n();
  export default defineComponent({
    components: { BasicModal, BasicForm },
    props: {
      userData: { type: Object },
    },
    emits: ['register', 'submit'],
    setup(props, { emit }) {
      const modelRef = ref({});
      const { createMessage } = useMessage();
      const schemas: FormSchema[] = [
        {
          field: 'companyName',
          component: 'Input',
          required: true,
          label: t('routes.corporation.enterpriseName'),
          componentProps: {
            maxLength: 20,
          },
          colProps: {
            span: 22,
          },
        },
        {
          field: 'managerPhone',
          component: 'Input',
          label: t('sys.login.corporationMail'),
          rules: [
            {
              required: true,
              // @ts-ignore
              validator: async (rule, value) => {
                // var reg_tel =
                //   /^(13[0-9]|14[01456879]|15[0-35-9]|16[2567]|17[0-8]|18[0-9]|19[0-35-9])\d{8}$/;
                var reg = /\S+@\S+\.\S+/;
                if (!value) {
                  /* eslint-disable-next-line */

                  return Promise.reject(t('sys.login.fillMail'));
                }
                if (!reg.test(value)) {
                  /* eslint-disable-next-line */
                  return Promise.reject(t('sys.login.fillMailCorrect'));
                }
                return Promise.resolve();
              },
              trigger: 'change',
            },
          ],
          colProps: {
            span: 22,
          },
        },
        {
          field: 'managerName',
          component: 'Input',
          label: t('routes.corporation.managerName'),

          required: true,
          componentProps: {
            maxLength: 85,
          },
          colProps: {
            span: 22,
          },
        },
        {
          field: 'address',
          component: 'Input',
          label: t('routes.corporation.address'),
          required: true,
          colProps: {
            span: 22,
          },
          componentProps: {
            maxLength: 50,
          },
        },
        {
          field: 'logo',
          component: 'Upload',
          label: t('routes.corporation.companyLogo'),
          required: true,
          rules: [{ required: true, message: t('routes.system.fileImgTips') }],
          helpMessage: t('routes.system.fileImgTipsType'),
          componentProps: {
            api: uploadLogoApi,
            maxNumber: 1,
            maxSize: 10,
            onChange: async () => {
              await validateFields(['logo']);
            },
            accept: ['jpg', 'jpeg', 'gif', 'png'],
            afterFetch: function (data) {
              console.log('data', data);
              Reflect.set(data, 'url', data.data);
              return data;
            },
          },

          colProps: {
            span: 22,
          },
        },
        {
          field: 'introduce',
          component: 'InputTextArea',
          label: t('routes.corporation.introduce'),
          required: true,
          colProps: {
            span: 22,
          },
          componentProps: {
            maxLength: 200,
          },
        },
      ];
      const [
        registerForm,
        {
          // getFieldsValue,
          // setFieldsValue,
          validateFields,
          resetFields,
          validate,
        },
      ] = useForm({
        labelWidth: 120,
        schemas,
        showActionButtonGroup: false,
        actionColOptions: {
          span: 24,
        },
      });
      let addListFunc = () => {};
      const [register, { closeModal }] = useModalInner((data) => {
        data && onDataReceive(data);
      });

      function onDataReceive(data) {
        console.log('Data Received', data);
      }
      const handleSubmit = async () => {
        const values = await validate();

        const insertData = {
          ...values,
          logo: values.logo[0],
        };
        console.log('insertData', insertData);
        //TODO hack parameter
        const res = await insertCompnayApi(insertData);
        // let res = await checkUserAddAble({ phoneNum: values.managerPhone });
        console.log('res', res);
        emit('submit');
        closeModal();
        resetFields();
        createMessage.success(t('routes.corporation.optSuccess'));
      };
      function handleVisibleChange(v) {
        v && props.userData && nextTick(() => onDataReceive(props.userData));
      }

      return {
        t,
        register,
        schemas,
        registerForm,
        model: modelRef,
        handleVisibleChange,
        handleSubmit,
        addListFunc,
        closeModal,
        resetFields,
        // nextTick,
      };
    },
  });
</script>
